﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Autolaskuri2
{
    /// <summary>
    /// Interaction logic for UserControl1.xaml
    /// </summary>
    /// Huom. namespace ja luokka eivät saa olla samaa nimeä. Ei siis toimi jos kumpikin on Autolaskuri2
    public partial class AutolaskuriButton : Button
    {
        public AutolaskuriButton()
        {
            InitializeComponent();
        }

        private void Button_Loaded(object sender, RoutedEventArgs e)
        {
//            Content = "Lisää auto";
        }

        private void buttonLaskuri_Click(object sender, RoutedEventArgs e)
        {
            //            textBoxLaskuri.Text = (Convert.ToInt16(textBoxLaskuri.Text) + 1).ToString
            Laskuri = Laskuri + 1;
        }
        // nimeäminen tehtävä juuri seuraavalla tavalla
        public static readonly DependencyProperty LaskuriProperty =
    DependencyProperty.Register(
        "Laskuri", typeof(int), typeof(AutolaskuriButton),
        new FrameworkPropertyMetadata(0, FrameworkPropertyMetadataOptions.AffectsRender, new PropertyChangedCallback(OnValueChanged),
                                      new CoerceValueCallback(MuutaLaskuria)));

        public int Laskuri
        {
            get { return (int)GetValue(LaskuriProperty); }
            set { SetValue(LaskuriProperty, value); }
        }

        private static object MuutaLaskuria(DependencyObject element, object value)
        {
            int luku = (int)value;
            if (luku < 0) value = 0;

            return luku;
        }

        private static void OnValueChanged(DependencyObject obj, DependencyPropertyChangedEventArgs args)
        {
            AutolaskuriButton o = (AutolaskuriButton)obj;

            RoutedPropertyChangedEventArgs<int> e = new RoutedPropertyChangedEventArgs<int>(
                (int)args.OldValue, (int)args.NewValue, ValueChangedEvent);
            o.OnValueChanged(e);
        }

        public static readonly RoutedEvent ValueChangedEvent = EventManager.RegisterRoutedEvent(
            "ValueChanged", RoutingStrategy.Bubble,
            typeof(RoutedPropertyChangedEventHandler<int>), typeof(AutolaskuriButton));

        public event RoutedPropertyChangedEventHandler<int> ValueChanged
        {
            add { AddHandler(ValueChangedEvent, value); }
            remove { RemoveHandler(ValueChangedEvent, value); }
        }

        protected virtual void OnValueChanged(RoutedPropertyChangedEventArgs<int> args)
        {
            RaiseEvent(args);
        }



    }
}
