﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Globalization;

namespace luento13
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public reseptitEntities Ctx;
        public MainWindow()
        {
            InitializeComponent();
            Ctx = new reseptitEntities();
        }

        // esimerkki tyypinmuunnoksesta
        public class IntToStringConverter: IValueConverter
        {
            public object Convert(
             object value, Type targetType,
             object parameter, CultureInfo culture)
            {
                return value.ToString();
            }

            public object ConvertBack(
             object value, Type targetType,
             object parameter, CultureInfo culture)
            {
                return Int16.Parse((string)value);
            }
        }

        private void autolaskuri2_ValueChanged(object sender, RoutedPropertyChangedEventArgs<int> e)
        {
            Title = ((Autolaskuri.Autolaskuri)sender).Laskuri.ToString();
        }

    
    }

    // kopioitu täältä: http://www.mindscape.co.nz/blog/index.php/2009/02/01/attached-behaviours-in-wpf/
    public static class InputBehaviour
    {
        public static bool GetIsDigitOnly(DependencyObject obj)
        {
            return (bool)obj.GetValue(IsDigitOnlyProperty);
        }

        public static void SetIsDigitOnly(DependencyObject obj, bool value)
        {
            obj.SetValue(IsDigitOnlyProperty, value);
        }

        public static readonly DependencyProperty IsDigitOnlyProperty =
          DependencyProperty.RegisterAttached("IsDigitOnly",
          typeof(bool), typeof(InputBehaviour),
          new UIPropertyMetadata(false, OnIsDigitOnlyChanged));

        private static void OnIsDigitOnlyChanged(object sender, DependencyPropertyChangedEventArgs e)
{
  // ignoring error checking
  TextBox textBox = (TextBox)sender;
  bool isDigitOnly = (bool)(e.NewValue);
 
  if (isDigitOnly)
    textBox.PreviewTextInput += BlockNonDigitCharacters;
  else
    textBox.PreviewTextInput -= BlockNonDigitCharacters;
}
 
private static void BlockNonDigitCharacters(object sender, TextCompositionEventArgs e)
{
  foreach (char ch in e.Text)
    if (!Char.IsDigit(ch))
      e.Handled = true;
}
    }

}
